<?xml version="1.0"?>

<!--
  * xmLPdoc, version alpha-2000/04/09.
  *
  *** Unfortunately, this XSLT script requires the
  *** Apache Xalan processor specifically, as there is
  *** not yet a standard for generating multiple output
  *** files from a single run of an XSLT script.
  *
  * Pre-alpha XSLT example, showing how an (X)HTML document
  * with embedded code fragments can be tangled using XSL
  * to produce (textual) source files.
  *
  * The aim of this stylesheet is to mimic some of what
  * FunnelWeb 3.05AC could do in creating source files.
  * (see "http://www.theoffice.net/abcoates/funnelweb.html").
  * However, this is really just a very early sample,
  * and subject to change without notice.
  *
  * Use as you will, no warranties of any kind, express or implied.
  * If you modify this and redistribute it, you must change the name
  * from "xmLP" to something sufficiently different that it will not
  * be confused with "xmLP".
  *
  * Name "xmLP" is copyright (C) 2000 Anthony B. Coates.
  -->

<xsl:transform
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lp="http://www.litprog.org/xmLP/alpha-2000-04-09/"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:redirect="org.apache.xalan.xslt.extensions.Redirect"
  extension-element-prefixes="redirect"
  version="1.0"
>

<xsl:output method="text" indent="no"/>

  <!-- Default rule:
       Do not tangle anything unless told to explicitly.
    -->
  <xsl:template match="*|@*|text()|comment()"/>

  <!-- Locate the files to be tangled, and tangle them.
    -->
  <xsl:template match="/">
    <xsl:text>----
</xsl:text>
    <xsl:for-each select="//lp:file">
      <xsl:variable name="filename" select="@lp:filename"/>
      <xsl:text>Tangling: </xsl:text>
      <xsl:value-of select="$filename"/>
      <xsl:text> ...
</xsl:text>
      <redirect:write select="$filename">
        <xsl:for-each select="lp:code">
          <xsl:for-each select="*|text()">
            <xsl:choose>
              <xsl:when test="self::text()">
                <xsl:value-of select="."/>
              </xsl:when>
              <xsl:when test="self::lp:invoke">
                <xsl:call-template name="invoke-macro">
                  <xsl:with-param name="macro-name" select="lp:name"/>
                </xsl:call-template>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </redirect:write>
    </xsl:for-each>
    <xsl:text>Done.
----
</xsl:text>
  </xsl:template>

  <xsl:template name="invoke-macro">
    <xsl:param name="macro-name"/>
    <xsl:for-each select="//lp:macro/lp:name">
      <xsl:variable name="current-name" select="text()"/>
      <xsl:if test="$current-name = $macro-name">
        <xsl:for-each select="../lp:code">
          <xsl:for-each select="*|text()">
            <xsl:choose>
              <xsl:when test="self::text()">
                <xsl:value-of select="."/>
              </xsl:when>
              <xsl:when test="self::lp:invoke">
                <xsl:call-template name="invoke-macro">
                  <xsl:with-param name="macro-name" select="lp:name"/>
                </xsl:call-template>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>

</xsl:transform>

<!-- End of xmLPtangle.xsl -->
